<?php
/**
 * @file
 * Settings form for Domain agggregate js css.
 */

namespace Drupal\domain_wise_aggregation\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

class DomainAggregateSettingForm extends FormBase {
  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'domain_aggregate_settings';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state, $domain = NULL) {
    $result = array();
    $css_optimization_status = "";
    $js_optimization_status = "";
    $domain_id_value = $domain;
    $db = \Drupal::database();
    $query = $db->select('domain_aggregate_compress', 'aadv');
    $query->fields('aadv', array('css_optimization_status', 'js_optimization_status'));
    $query->condition('aadv.domain_id', $domain_id_value);
    $resultset = $query->execute();
    $result = $resultset->fetchAll();
    
    if (count($result) > 0 && !empty($result)) {
      foreach ($result as $value) {
        $css_optimization_status = $value->css_optimization_status;
        $js_optimization_status = $value->js_optimization_status;
      }
    }
    $config = $this->config('domain_aggregate.settings');
    $form['contents'] = array(
      'css_optimization_status' => array(
        '#type' => 'checkbox',
        '#default_value' => !empty($form_state->getValue('css_optimization_status')) ? $form_state->getValue('css_optimization_status') : $css_optimization_status,
        '#title' => t('Aggregate and Compress css files'),
      ),
      'js_optimization_status' => array(
        '#type' => 'checkbox',
        '#default_value' => !empty($form_state->getValue('js_optimization_status')) ? $form_state->getValue('js_optimization_status') : $js_optimization_status,
        '#title' => t('Aggregate and Compress js files'),
      ),
      'domain_id' => array(
        '#type' => 'hidden',
        '#value' => $domain_id_value,
      ),
    );
    $form['submit'] = array(
      '#type' => 'submit',
      '#name' => 'save',
      '#value' => t('Submit')
    );
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $db = \Drupal::database();
    $query = $db->select('domain_aggregate_compress', 'aadv');
    $query->fields('aadv', array('css_optimization_status', 'js_optimization_status'));
    $query->condition('aadv.domain_id', $form_state->getValue('domain_id'));
    $resultset = $query->execute();
    $result = $resultset->fetchAll();
    if(empty($result)) {
      $db = \Drupal::database();
      $result = $db->insert('domain_aggregate_compress')
        ->fields(array(
          'domain_id' => $form_state->getValue('domain_id'),
          'css_optimization_status' => $form_state->getValue('css_optimization_status'),
          'js_optimization_status' => $form_state->getValue('js_optimization_status'),
        ))
        ->execute();
    }
    else {
      $db = \Drupal::database();
      $result = $db->update('domain_aggregate_compress')
        ->fields(array(
          'domain_id' => $form_state->getValue('domain_id'),
          'css_optimization_status' => $form_state->getValue('css_optimization_status'),
          'js_optimization_status' => $form_state->getValue('js_optimization_status'),
        ))->condition('domain_id', $form_state->getValue('domain_id'))
        ->execute();
    }
  }
}